// TrayDate.cpp : AvP[Vp̃Gg |Cg̒`
//

#include	"stdafx.h"
#include	"resource.h"


//-----------------------------------------------------------------------------
//  D E F I N E S
//-----------------------------------------------------------------------------
#define		TIMER_ID		1
#define		TRAYICON_ID		IDI_TRAY
#define		WM_USER_TRAY	WM_USER + 0x10		// 0x410

#define		EXPIRE_SIZE		8



//-----------------------------------------------------------------------------
//  G L O B A L  V A R I A B L E S
//-----------------------------------------------------------------------------
HINSTANCE	hInst;
SYSTEMTIME	tmSave;

const char	sRegKey[]	= "Software\\WanSystem\\TrayDate";
const char	srDate[]	= "Date";
const char	srExpire[]	= "Expire";
const char	srExit[]	= "Exit";

const char	srFile[]	= "FileName";
const char	srDir[]		= "Dir";
const char	srArg[]		= "Arguments";

const char	sRunInfo[]	= "spX:\t%s\r\nIvV:\t%s\r\ntH_:\t%s";

char		sFilePath[MAX_PATH]	= "";
char		sDirPath[MAX_PATH]	= "";
char		sArgument[MAX_PATH]	= "";



//-----------------------------------------------------------------------------
//	fx:			LoadString̊ȗ
inline int LoadText(
		UINT	uID,
		char*	sBuf )
//-----------------------------------------------------------------------------
{
	return LoadString( hInst, uID, sBuf, 128 );
}


//-----------------------------------------------------------------------------
//	fx:			z݂̎̂Rs[
SYSTEMTIME* TimeCopy(
		SYSTEMTIME*	tmDest,			// Rs[
		SYSTEMTIME*	tmSrc )			// Rs[
//-----------------------------------------------------------------------------
{
	tmDest->wHour			= tmSrc->wHour;
	tmDest->wMinute			= tmSrc->wMinute;
	tmDest->wSecond			= tmSrc->wSecond;
	tmDest->wMilliseconds	= tmSrc->wMilliseconds;
	return tmDest;
}


//-----------------------------------------------------------------------------
//	fx:			z̓t݂̂Rs[
SYSTEMTIME* DateCopy(
		SYSTEMTIME*	tmDest,			// Rs[
		SYSTEMTIME*	tmSrc )			// Rs[
//-----------------------------------------------------------------------------
{
	tmDest->wYear		= tmSrc->wYear;
	tmDest->wMonth		= tmSrc->wMonth;
	tmDest->wDayOfWeek	= tmSrc->wDayOfWeek;
	tmDest->wDay		= tmSrc->wDay;
	return tmDest;
}


//-----------------------------------------------------------------------------
//	fx:			bbɕϊ
inline int TimeToSecond(
		SYSTEMTIME*	systime )
//-----------------------------------------------------------------------------
{
	return (	systime->wHour		* 60 * 60
			+	systime->wMinute	* 60
			+	systime->wSecond );
}


//-----------------------------------------------------------------------------
//	fx:			Ԃ𖳌/Lɂ
void SetState(
		HWND	hWnd,				// Buttoñnh
		bool	bEnabled )			// TRUE=L
//-----------------------------------------------------------------------------
{
	long stOld;

	stOld = GetWindowLong( hWnd, GWL_STYLE );
	SetWindowLong( hWnd, GWL_STYLE,
		bEnabled?(stOld & ~WS_DISABLED):(stOld | WS_DISABLED) );
}


//-----------------------------------------------------------------------------
//	fx:			gCACR
bool TrayIcon(
		HWND	hDlg,
		DWORD	dwPost,				// NIM_ADD, NIM_DELETE, NIM_MODIFY
		UINT	uIconID = NULL,		// ACR̃\[XID
		char*	sText = NULL )
//-----------------------------------------------------------------------------
{
	NOTIFYICONDATA tnid;

	// \̏
	ZeroMemory( &tnid, sizeof(NOTIFYICONDATA) );
	tnid.cbSize = sizeof(NOTIFYICONDATA);
	tnid.hWnd = hDlg;
	tnid.uID = TRAYICON_ID;

	// ʒmeŏꍇ
	switch( dwPost ) {
		case NIM_ADD:			// ǉ
		case NIM_MODIFY:		// ύX
			HICON hIcon;
			hIcon = LoadIcon( hInst, MAKEINTRESOURCE(uIconID) );

			tnid.uFlags = NIF_ICON | NIF_MESSAGE;
			tnid.uCallbackMessage = WM_USER_TRAY;
			tnid.hIcon = hIcon;

			if( sText ) {
				strcpy( tnid.szTip, sText );
				tnid.uFlags |= NIF_TIP;
			}
			break;

		case NIM_DELETE:		// 폜
			break;

		default:				// ?
			return FALSE;
	}

	// VFɒʒm
	if( !Shell_NotifyIcon(dwPost, &tnid) )
		return FALSE;

	return TRUE;
}


//-----------------------------------------------------------------------------
//	fx:			_CAOIO
void DlgExit(
		HWND	hDlg )
//-----------------------------------------------------------------------------
{
	HKEY hKey;
	DWORD dwDisp;

	// create handle
	RegCreateKeyEx(
		HKEY_CURRENT_USER,
		sRegKey,
		0,
		NULL,
		REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS,
		NULL,
		&hKey,
		&dwDisp );

	// write date
	SYSTEMTIME tmSetting;
	MonthCal_GetCurSel( GetDlgItem(hDlg, IDCMC_DATE), &tmSetting );

	RegSetValueEx(
		hKey,
		srDate,
		0,
		REG_BINARY,
		(CONST BYTE*)&tmSetting,
		sizeof(SYSTEMTIME) );

	// write expire setting
	char sExpire[EXPIRE_SIZE];
	GetDlgItemText( hDlg, IDCE_EXPIRE, sExpire, sizeof(sExpire) );

	RegSetValueEx(
		hKey,
		srExpire,
		0,
		REG_SZ,
		(CONST BYTE*)sExpire,
		sizeof(sExpire) );

	// write exit setting
	DWORD dwExit = 0;
	dwExit = (DWORD)( IsDlgButtonChecked(hDlg, IDCC_EXIT) == BST_CHECKED );

	RegSetValueEx(
		hKey,
		srExit,
		0,
		REG_DWORD,
		(CONST BYTE*)&dwExit,
		sizeof(DWORD) );

	// write file-name setting
	RegSetValueEx(
		hKey,
		srFile,
		0,
		REG_SZ,
		(CONST BYTE*)sFilePath,
		sizeof(sFilePath) );

	// write directory setting
	RegSetValueEx(
		hKey,
		srDir,
		0,
		REG_SZ,
		(CONST BYTE*)sDirPath,
		sizeof(sDirPath) );

	// write arguments setting
	RegSetValueEx(
		hKey,
		srArg,
		0,
		REG_SZ,
		(CONST BYTE*)sArgument,
		sizeof(sArgument) );

	// release handle
	RegCloseKey( hKey );

	// remove tray icon
	TrayIcon( hDlg, NIM_DELETE );
	EndDialog( hDlg, 0 );
}


//-----------------------------------------------------------------------------
//	fx:			_CAO - ύX(C)
bool Dlg_Change(
		HWND	hDlg )
//-----------------------------------------------------------------------------
{
	HWND hwCAL;
	hwCAL = GetDlgItem( hDlg, IDCMC_DATE );

	// ݂Ɛݒ擾
	SYSTEMTIME tmGet;
	if( !MonthCal_GetCurSel(hwCAL, &tmGet) )
		return FALSE;
	GetLocalTime( &tmSave );

	// ̃Rs[ƐVt̃Zbg
	TimeCopy( &tmGet, &tmSave );
	SetLocalTime( &tmGet );

	// ̕\
	char sText[128], sRes[128];
	LoadText( IDS_CHANGED, sRes );

	sprintf( sText, sRes, tmSave.wYear, tmSave.wMonth, tmSave.wDay );
	SetDlgItemText( hDlg, IDCS_INFO, sText );

	// gC̕ύX
	TrayIcon( hDlg, NIM_MODIFY, IDI_CHANGED, sText );

	// ύX(C)̖A߂(B)̗L
	SetState( GetDlgItem(hDlg, IDCB_BACK), TRUE );
	SetState( GetDlgItem(hDlg, IDCB_CHANGE), FALSE );

	// ^C}[̃Zbg
	int iSec;
	if( iSec = (int)GetDlgItemInt(hDlg, IDCE_EXPIRE, NULL, TRUE) )
		SetTimer( hDlg, TIMER_ID, iSec * 1000, NULL );

	// ݒύXs
	SetState( hwCAL, FALSE );
	SetState( GetDlgItem(hDlg, IDCE_EXPIRE), FALSE );
	SetState( GetDlgItem(hDlg, IDCC_EXIT), FALSE );

	RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE );

	// execute
	if( IsDlgButtonChecked(hDlg, IDCC_RUN) != BST_CHECKED )
		return TRUE;

	STARTUPINFO startup;
	PROCESS_INFORMATION process;

	ZeroMemory( &startup, sizeof(startup) );
	startup.cb			= sizeof(STARTUPINFO);
	startup.dwFlags		= STARTF_USESHOWWINDOW;
	startup.wShowWindow	= SW_SHOWDEFAULT;

	CreateProcess(
		sFilePath, sArgument,
		NULL, NULL, FALSE,
		CREATE_DEFAULT_ERROR_MODE | NORMAL_PRIORITY_CLASS, NULL,
		sDirPath, &startup, &process );

	CloseHandle( process.hThread );
	CloseHandle( process.hProcess );

	return TRUE;
}


//-----------------------------------------------------------------------------
//	fx:			_CAO - ߂(&B)
bool Dlg_Restore(
		HWND	hDlg,
		bool	IsExpire )			// TRUE=؂ɂ
//-----------------------------------------------------------------------------
{
	HWND hwCAL;
	hwCAL = GetDlgItem( hDlg, IDCMC_DATE );

	// ^C}[𖳌ɂ
	KillTimer( hDlg, TIMER_ID );

	// ݎƐݒ擾
	SYSTEMTIME tmGet, tmNow;
	GetLocalTime( &tmNow );
	if( !MonthCal_GetCurSel(hwCAL, &tmGet) )
		return FALSE;

	//
	//	real						system				
	//	---------------------------+---------------------------+----
	//	1/31  					 1/31  
	//	1/31  23:59:50(86390 Save)	10/31  23:59:50				ύX
	//	2/ 1  00:00:00				11/ 1  00:00:00
	//	2/ 1  00:00:10				11/ 1  00:00:10(10 Get)		/߂
	//															׍H
	//	2/ 1  					 2/ 1  00:00:10
	//

	// ςĂȂ
	if( tmGet.wDay != tmNow.wDay )
	{
		SYSTEMTIME tmTemp = { 0, 0, 0, 0, 23, 59, 59, 999 };

		// tmSave̓t23:59:59.999Kp
		DateCopy( &tmTemp, &tmSave );
		SetLocalTime( &tmTemp );

		// ҋ@
		do
			GetLocalTime( &tmTemp );
		while( tmTemp.wMilliseconds == 999 );

		// tmNow̍XV
		GetLocalTime( &tmNow );
	}

	// ̃Rs[ƌÂt̃Zbg
	TimeCopy( &tmSave, &tmNow );
	SetLocalTime( &tmSave );

	// ̕\
	char sText[128];
	LoadText( IDS_RESTORED, sText );
	SetDlgItemText( hDlg, IDCS_INFO, sText );

	// gC߂
	TrayIcon( hDlg, NIM_MODIFY, IDI_TRAY, sText );

	// ύX(C)̗LA߂(B)̖
	SetState( GetDlgItem(hDlg, IDCB_CHANGE), TRUE );
	SetState( GetDlgItem(hDlg, IDCB_BACK), FALSE );

	// IɏI
	if( (IsDlgButtonChecked(hDlg, IDCC_EXIT) == BST_CHECKED) && IsExpire )
		DlgExit( hDlg );

	// ݒύX
	SetState( hwCAL, TRUE );
	SetState( GetDlgItem(hDlg, IDCE_EXPIRE), TRUE );
	SetState( GetDlgItem(hDlg, IDCC_EXIT), TRUE );

	RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE );

	return TRUE;
}


//-----------------------------------------------------------------------------
//	fx:			_CAO
void DlgInit(
		HWND	hDlg )
//-----------------------------------------------------------------------------
{
	// ߂(B)̖
	SetState( GetDlgItem(hDlg, IDCB_BACK), FALSE );

	// SPIN͈̔
	HWND hwSP;
	hwSP = GetDlgItem( hDlg, IDC_SPIN );
	SendMessage( hwSP, UDM_SETRANGE, 0, MAKELONG(0, 32) );

	// SPIN̕ω
	UDACCEL uac;
	uac.nInc = (UINT)(-1);
	uac.nSec = 1;
	SendMessage( hwSP, UDM_SETACCEL, 1, (LPARAM)&uac );

	// CAL̑傫
	HWND hwCAL;
	hwCAL = GetDlgItem( hDlg, IDCMC_DATE );

	RECT rt;
	MonthCal_GetMinReqRect( hwCAL, &rt );
	SetWindowPos( hwCAL, NULL, NULL, NULL,
		rt.right + GetSystemMetrics(SM_CXEDGE),
		rt.bottom + GetSystemMetrics(SM_CYEDGE),
		SWP_NOMOVE | SWP_NOZORDER );

	// run file setting
	CheckDlgButton( hDlg, IDCC_RUN, BST_CHECKED );

	// ^XNgCɒǉ
	char sText[64];
	LoadText( IDS_INIT, sText );

	TrayIcon( hDlg, NIM_ADD, IDI_TRAY, sText );

	// registry
	HKEY hKey;
	DWORD dwDisp;

	// create handle
	RegCreateKeyEx(
		HKEY_CURRENT_USER,
		sRegKey,
		0,
		NULL,
		REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS,
		NULL,
		&hKey,
		&dwDisp );

	if( dwDisp == REG_OPENED_EXISTING_KEY )
	{
		// vars
		DWORD dwType, dwSize;

		// read date
		SYSTEMTIME tmSetting;
		dwSize = sizeof(SYSTEMTIME);

		RegQueryValueEx(
			hKey,
			srDate,
			0,
			&dwType,
			(PBYTE)&tmSetting,
			&dwSize );
		MonthCal_SetCurSel( GetDlgItem(hDlg, IDCMC_DATE), &tmSetting );

		// read expire setting
		char sExpire[EXPIRE_SIZE];
		dwSize = sizeof(sExpire);

		RegQueryValueEx(
			hKey,
			srExpire,
			0,
			&dwType,
			(PBYTE)sExpire,
			&dwSize );
		SetDlgItemText( hDlg, IDCE_EXPIRE, sExpire );

		// read exit setting
		DWORD dwExit = 0;
		dwSize = sizeof(dwExit);

		RegQueryValueEx(
			hKey,
			srExit,
			0,
			&dwType,
			(PBYTE)&dwExit,
			&dwSize );
		CheckDlgButton(
			hDlg, IDCC_EXIT,
			dwExit ? BST_CHECKED : BST_UNCHECKED );

		// read file-name setting
		dwSize = sizeof(sFilePath);
		RegQueryValueEx(
			hKey,
			srFile,
			0,
			&dwType,
			(PBYTE)sFilePath,
			&dwSize );

		// read directory setting
		dwSize = sizeof(sDirPath);
		RegQueryValueEx(
			hKey,
			srDir,
			0,
			&dwType,
			(PBYTE)sDirPath,
			&dwSize );

		// read arguments setting
		dwSize = sizeof(sArgument);
		RegQueryValueEx(
			hKey,
			srArg,
			0,
			&dwType,
			(PBYTE)sArgument,
			&dwSize );
	}

	// release handle
	RegCloseKey( hKey );

	// exe info
	char sExec[1024];
	sprintf( sExec, sRunInfo, sFilePath, sArgument, sDirPath );
	SetDlgItemText( hDlg, IDCS_INFO, sExec );
}


//-----------------------------------------------------------------------------
//  C A L L B A C K   F U N C T I O N S  (stdcall)
//-----------------------------------------------------------------------------

// _CAO - IDD_EXEC
BOOL APIENTRY DlgProc_Exec( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
		case WM_INITDIALOG:
			SetDlgItemText( hDlg, IDCE_EXE, sFilePath );
			SetDlgItemText( hDlg, IDCE_ARG, sArgument );
			SetDlgItemText( hDlg, IDCE_DIR, sDirPath );
			return TRUE;

		case WM_COMMAND:
			switch( LOWORD(wParam) )
			{
				case IDCANCEL:
					break;

				case IDOK:
					GetDlgItemText( hDlg, IDCE_EXE, sFilePath, sizeof(sFilePath) );
					GetDlgItemText( hDlg, IDCE_ARG, sArgument, sizeof(sArgument) );
					GetDlgItemText( hDlg, IDCE_DIR, sDirPath, sizeof(sDirPath) );

					if( sArgument[0] == NULL )
						strcpy( sArgument, "\"\"" );

					break;

				default:
					return FALSE;
			}

			EndDialog( hDlg, 0 );
			return TRUE;

		// get file-name
		case WM_DROPFILES:
			char sName[MAX_PATH];

			DragQueryFile( (HDROP)wParam, 0, sName, sizeof(sName) );
			DragFinish( (HDROP)wParam );

			SetDlgItemText( hDlg, IDCE_EXE, sName );
			return TRUE;
	}
	return FALSE;
}


// _CAO - IDC_MAIN
BOOL APIENTRY DlgProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
		// _CAO
		case WM_INITDIALOG:
			DlgInit( hDlg );
			return TRUE;

		case WM_COMMAND:
			switch( LOWORD(wParam) ) {
				case IDCANCEL:				// 
					DlgExit( hDlg );
					break;

				case IDCB_CHANGE:			// ύX(C)
					Dlg_Change( hDlg );
					break;

				case IDCB_BACK:				// ߂(B)
					Dlg_Restore( hDlg, FALSE );
					break;

				case IDCB_EXE:
					DialogBoxParam(
						hInst,
						MAKEINTRESOURCE(IDD_EXEC),
						hDlg,
						(DLGPROC)DlgProc_Exec,
						0 );

					char sText[1024];
					sprintf( sText, sRunInfo, sFilePath, sArgument, sDirPath );
					SetDlgItemText( hDlg, IDCS_INFO, sText );
					break;

				default:
					return FALSE;
			}
			return TRUE;

		// ^C}
		case WM_TIMER:
			if( wParam == TIMER_ID ) {
				Dlg_Restore( hDlg, TRUE );
				return TRUE;
			}
			return FALSE;

		// ^XNgC
		case WM_USER_TRAY:
			switch( lParam ) {
				case WM_LBUTTONDOWN:
				case WM_RBUTTONDOWN:
					SetForegroundWindow( hDlg );
					break;

				default:
					return FALSE;
			}
			return TRUE;
	}
	return FALSE;
}

// Gg|Cg
int APIENTRY WinMain( HINSTANCE hInstance,
					  HINSTANCE hPrevInstance,
					  LPSTR lpCmdLine,
					  int nCmdShow )
{
	// O[oϐ̏
	hInst = hInstance;

	// RRg[̏
	INITCOMMONCONTROLSEX icex;
	icex.dwSize = sizeof(icex);
	icex.dwICC = ICC_DATE_CLASSES;
	InitCommonControlsEx( &icex );

	// _CAOs
	return (int)DialogBox( hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)DlgProc );
}



